with t as (
select 1 dept_key, 'Test' name, 3 parent_dept_key from dual UNION ALL
select 2 dept_key, 'Test1' name, 1 parent_dept_key from dual UNION ALL
select 3 dept_key, 'Test2' name, 3 parent_dept_key from dual )
select dept_key, 
       name, 
       parent_dept_key, 
       connect_by_root(name) parent_name,
       level lvl
from t
connect by nocycle
prior dept_key = parent_dept_key
  and level <= 2
order by dept_key, lvl;

with t as (
select 1 dept_key, 'Test' name, 3 parent_dept_key from dual UNION ALL
select 2 dept_key, 'Test1' name, 1 parent_dept_key from dual UNION ALL
select 3 dept_key, 'Test2' name, 3 parent_dept_key from dual )
select dept_key, 
       name, 
       parent_dept_key, 
       connect_by_root(name) parent_name,
       level lvl,
       max(level) over (partition by dept_key) m
from t
connect by nocycle
prior dept_key = parent_dept_key
  and level <= 2
order by dept_key, lvl;

